/*
** Copyright 1997 TICK (t_i_c_k@hotmail.com)
*/

#ifndef __COL_HDR
#define __COL_HDR

#include <string.h>


/* -------------- Error handling -> errno-style --------------------------- */

#define ECOL_INIT1ST  0
#define ECOL_SEND     1
#define ECOL_SOCKET   2
#define ECOL_MEMORY   3
#define ECOL_BIND     4
#define ECOL_FULL     5

extern int  col_error;


/* -------------- Stuff for Connection Set -> select()-style ------------- */

typedef unsigned long col_set;  /* 32 Bit -> max. 32 "connections" */

#define __CS_MASK(s)      ( 1 << s )
#define CS_ZERO(set)      ( set &= 0x00000000 )
#define CS_SET(s, set)    ( set |= __CS_MASK(s-1) )
#define CS_CLR(s, set)    ( set &= ~__CS_MASK(s-1) )
#define CS_ISSET(s, set)  ( set & __CS_MASK(s-1) )


/* -------------- global Declarations of Lib.functions ------------------- */

extern int  ColInit(col_set *set, char *serv_ip, int port);
extern int  ColSend(col_set *set, char *str, ...);
extern int  ColClose(col_set *set);


#endif
