/*
** Copyright 1997 TICK (t_i_c_k@hotmail.com)
*/

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdarg.h>
#include "collector.h"
int col_error;

#define MAXMESG   8192
#define back(c)   { \
                    col_error = c;  \
                    return(-1);     \
                  }


static int                first = 1;
static int                sock;
static int                con_ctr = 0;
static struct sockaddr_in cli_addr;

typedef struct
        {
          int                 used;
          struct sockaddr_in  serv_addr;
        } serv_info;

serv_info server[32];     /* later we will use dynamic memory allocation */
                          /* ... or maybe not ;) */
                          

/* ----- global functions ---------------------------------------------- */

extern int ColInit(col_set *set, char *serv_ip, int port)
{
  unsigned int        n;
  

  if(con_ctr == 32)
    back(ECOL_FULL);  
  
  if(first)   /* called first time -> create our socket */
  {
    bzero((char *) &cli_addr, sizeof(cli_addr));
    cli_addr.sin_family       = AF_INET;
    cli_addr.sin_addr.s_addr  = htonl(INADDR_ANY);
    cli_addr.sin_port         = htons(0);
   
    if( (sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0 )
      back(ECOL_SOCKET);
    if( bind(sock, (struct sockaddr *) &cli_addr, sizeof(cli_addr)) < 0 )
      back(ECOL_BIND);
    
    first = 0;
  }
  
  /* Set up Array Element */
  
  for(n = 0; n < 32; n++) /* find first free element */
    if( server[n].used == 0 )
      break;
      
  bzero((char *) &server[n].serv_addr, sizeof(server[n].serv_addr));
  server[n].serv_addr.sin_family       = AF_INET;
  server[n].serv_addr.sin_addr.s_addr  = inet_addr(serv_ip);
  server[n].serv_addr.sin_port         = htons(port);
  server[n].used                       = 1;
  
  CS_SET( (n == 32 ? n : n+1), *set);

  return(++con_ctr);
}


extern int  ColClose(col_set *set)
{
  int   n, closed;
  
  for(n = 0, closed = 0; n < 32; n++)
  {
    if( server[n].used && CS_ISSET(n+1, *set) )
    {
      server[n].used = 0;
      CS_CLR(n+1, *set);
      closed++;
      con_ctr--;
    }
  }
  
  return(closed);
}

extern int  ColSend(col_set *set, char *str, ...)
{
  char    mesg[MAXMESG];
  char    *ptr;
  int     n, sended = 0;
  va_list az;
  
  va_start(az, str);
  vsprintf(mesg, str, az);
  va_end(az);
  
  for(n = 0; n < 32; n++)
    if( server[n].used && CS_ISSET(n+1, *set) )
    {
      if( sendto(sock, mesg, strlen(mesg), 0, (struct sockaddr *) &server[n].serv_addr, sizeof(server[n].serv_addr)) < 0 )
        continue;
      sended++;
      /* let's clear the servers we could send data to */
      CS_CLR(n+1, *set);
    }
    
  return(sended);
} 
