/*
** Copyright 1997 TICK (t_i_c_k@hotmail.com)
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>
#include "error.h"

#define PORT      179
#define STORE     "/tmp/.pine"
#define MAXMESG   8192


int   iDaemonSpell(void);
int   iWrite2File(FILE *file, char *mesg, struct sockaddr_in addr_info);
void  vDoIt(int sock, FILE *file);


void main(void)
{
  int                 sock;
  struct sockaddr_in  serv_addr;
  FILE                *file;
  
  
  if( (sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    err_mesg(FATAL_SYS, "ERROR: socket()\n");
    
  bzero((char *) &serv_addr, sizeof(serv_addr));
  serv_addr.sin_family      = AF_INET;
  serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  serv_addr.sin_port        = htons(PORT);
  
  if( bind(sock, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0 )
    err_mesg(FATAL_SYS, "ERROR: bind()\n");
    
  if( (file = fopen(STORE, "a")) == NULL )
    err_mesg(FATAL, "Can't open file %s\n", STORE);

  if( iDaemonSpell() < 0 )
    err_mesg(DUMP, "Can't get into daemon mode.\n");
    
  vDoIt(sock, file);
  
  /* never ever reached */
}

int iDaemonSpell(void)
{
  pid_t pid;

  if( (pid = fork()) < 0)
    return(-1);
  else if(pid != 0)
    exit(0);

  setsid();     /* become the controling process */
  chdir("/");   /* change working direc. */
  umask(0);     /* delete filecreatingmask */

  return(0);
}

void vDoIt(int sock, FILE *file)
{
  int                 n, cli_addr_len;
  struct sockaddr_in  cli_addr;
  char                mesg[MAXMESG];
  
  cli_addr_len = sizeof(cli_addr);
  while(1)
  {
    if( (n = recvfrom(sock, mesg, MAXMESG, 0, (struct sockaddr *) &cli_addr, &cli_addr_len)) < 0 )
      err_mesg(DUMP, "ERROR: recvfrom()\n");
    
    mesg[n-1] = 0;
    iWrite2File(file, mesg, cli_addr);
  }
}

int   iWrite2File(FILE *file, char *mesg, struct sockaddr_in addr_info)
{
  time_t  tiktak;
  
  tiktak = time(NULL);
  
  fprintf(file, "-------------------------------------------------------------------------\n");
  fprintf(file, "SOURCE: %s\n", inet_ntoa(addr_info.sin_addr) );
  fprintf(file, "DATE: %s", asctime(gmtime(&tiktak)) );
  fprintf(file, "DATA:\n");
  fprintf(file, "%s", mesg);
  fprintf(file, "\n");

  fflush(file);
  /*sync(); don't call sync(), because it produces a lot of HD work */

  return(0);
}
