/*
** Copyright 1997 TICK (t_i_c_k@hotmail.com)
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "error.h"

#define PORT      179
#define ADDR      "127.0.0.1"
#define STORE     "./test.data"
#define MAXMESG   8192

void  vTest(int sock);

void main(void)
{
  int                 sock;
  struct sockaddr_in  cli_addr;
  
  
  if( (sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0 )
    err_mesg(FATAL, "ERROR: socket()\n");
    
  bzero((char *) &cli_addr, sizeof(cli_addr));
  cli_addr.sin_family       = AF_INET;
  cli_addr.sin_addr.s_addr  = htonl(INADDR_ANY);
  cli_addr.sin_port         = htons(0);
  
  if( bind(sock, (struct sockaddr *) &cli_addr, sizeof(cli_addr)) < 0 )
    err_mesg(FATAL, "ERROR: bind()\n");
    
  vTest(sock);
}

void vTest(int sock)
{
  struct sockaddr_in  serv_addr;
  char                mesg[MAXMESG];
  FILE                *file;
  

  bzero((char *) &serv_addr, sizeof(serv_addr));
  serv_addr.sin_family      = AF_INET;
  serv_addr.sin_addr.s_addr = inet_addr(ADDR);
  serv_addr.sin_port        = htons(PORT);

  if( (file = fopen(STORE, "r")) == NULL)
    err_mesg(FATAL, "Can't open file %s\n", STORE);

  while( fgets(mesg, MAXMESG, file) )
    sendto(sock, mesg, strlen(mesg), 0, (struct sockaddr *) &serv_addr, sizeof(serv_addr));
  if(ferror(file))
    err_mesg(FATAL_SYS, "ERROR: fgets()\n");
  
  fclose(file);
}
