/*
** Copyright 1997 TICK (t_i_c_k@hotmail.com)
*/

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "error.h"
#include "icmp_tunnel.h"
extern int  eit_errno;

#define USAGE(prog) \
  err_mesg(FATAL, "\nusage:\t%s [-s] [-c] -n <name> [-h <host>]\n", prog);

#define BUFSIZE   512

#define CLOSE     "/bye"


int main(int argc, char **argv)
{
  char    mesg[MAXMESG], sndmesg[MAXMESG+BUFSIZE], rcvmesg[MAXMESG+BUFSIZE];
  char    name[BUFSIZE] = { 0 };
  int     n, opt;
  int     srvflag = 0, cliflag = 0, byeflag = 0;
  u_long  hostaddr = 0;

  
  if(argc < 4)
    USAGE(argv[0])

  opterr = 0;
  while( (opt = getopt(argc, argv, "scn:h:")) != EOF)
  {
    switch(opt)
    {
      case 's':
        srvflag++;
        break;
      case 'c':
        cliflag++;
        break;
      case 'n':
        strncpy(name, optarg, sizeof(name)-1);
        break;
      case 'h':
        hostaddr = nameResolve(optarg);
        break;
      default:
        USAGE(argv[0])
    }
  }
  
  if( (srvflag && cliflag) || (!srvflag && !cliflag) )
    err_mesg(FATAL, "\nHey, am I a Server or a Client?\n");
  if(!name[0])
    err_mesg(FATAL, "\nDo you have a Callsign?\n");
  if(!hostaddr && cliflag)
    err_mesg(FATAL, "\nPlease specify a Host!\n");

  if(srvflag)
    goto server;

  while( !ferror(stdin) && !feof(stdin) )
  {
    bzero(sndmesg, sizeof(sndmesg));
    bzero(rcvmesg, sizeof(rcvmesg));
      
    printf("%s: ", name);
    if( fgets(mesg, MAXMESG, stdin) == NULL)
      break;

    mesg[strlen(mesg)-1] = 0;
    if(strcmp(mesg, CLOSE))
    {
      strcpy(sndmesg, name);
      strcat(sndmesg, ": ");
    }
    else
      byeflag = 1;
    
    strcat(sndmesg, mesg);
       
    if(tunnel_send(sndmesg, strlen(sndmesg), hostaddr) < 0)
      err_mesg(FATAL_SYS, "ERROR: tunnel_send()\n");
     
    if(byeflag && cliflag)
      break;

server:
    if( (n = tunnel_recv(rcvmesg, MAXMESG)) < 0 )
      err_mesg(DUMP, "ERROR: tunel_recv()\n");

    if(srvflag)
      hostaddr = clisrc.sin_addr.s_addr;

    if(!strcmp(CLOSE, rcvmesg))
    {
      printf("Connection closed from %s\n", hostLookup(hostaddr));
      if(srvflag)
        goto server;
      else
        break;
    }

    printf("%s -> %s\n", hostLookup(hostaddr), rcvmesg);
  }
  
  tunnel_reset();
  
  exit(0);
}
